import argparse
import math
import socket


from pythonosc import dispatcher
from pythonosc import osc_server
from pythonosc import osc_message_builder
from pythonosc import udp_client

""" http://stackoverflow.com/questions/166506/finding-local-ip-addresses-using-pythons-stdlib
"""
def get_ip_address():
    return ([(s.connect(('8.8.8.8', 80)),s.getsockname()[0], s.close())
           for s in [socket.socket (socket.AF_INET, socket.SOCK_DGRAM)]][0][1])

class OscTouch:
    def __init__(self):
        self.channelcounter = 1
        self.client = udp_client.UDPClient(touch_ip, out_port)
        print("Sende zu Touch-Gerät {0}, Port {1}".format (touch_ip, out_port))
        self.sendcounter()

    def sendcounter(self):
        self.msg = osc_message_builder.OscMessageBuilder(address = "/1/label1")
        self.msg.add_arg (self.channelcounter)
        self.msg = self.msg.build()
        self.client.send (self.msg)

    def sendvalue(self, val):
        self.msg = osc_message_builder.OscMessageBuilder(address = "/1/label2")
        self.msg.add_arg (val)
        self.msg = self.msg.build()
        self.client.send (self.msg)

    def sub1(self, arg1, arg2): # -1
        if arg2 == 1:
            if self.channelcounter > 1:
                self.channelcounter -= 1
                self.sendcounter()

    def add1(self, arg1, arg2): # +1
        if arg2 == 1:
            if self.channelcounter < 512:
                self.channelcounter += 1
                self.sendcounter()

    def sub10(self, arg1, arg2): # -10
        if arg2 == 1:
            if self.channelcounter > 10:
                self.channelcounter -= 10
            else: self.channelcounter = 1
            self.sendcounter()

    def add10(self, arg1, arg2): #+10
        if arg2 == 1:
            if self.channelcounter < 502:
                self.channelcounter += 10
            else: self.channelcounter = 512
            self.sendcounter()
        
    def sub100(self, arg1, arg2): # -100
        if arg2 == 1:
            if self.channelcounter > 100:
                self.channelcounter -= 100
            else: self.channelcounter = 1
            self.sendcounter()

    def add100(self, arg1, arg2): # +100
        if arg2 == 1:
            if self.channelcounter < 412:
                self.channelcounter += 100
            else: self.channelcounter = 512
            self.sendcounter()

class OscOla:
    def __init__(self):
        self.chanval = 0
        self.channelcounter = 1
        self.client = udp_client.UDPClient(ola_ip, out_port)
        print("Sende zu OLA-Gerät {0}, Port {1}".format (ola_ip, out_port))
        # self.chanval senden

    def sendval(self, val):
        self.channelcounter = touch.channelcounter
        msgaddress = "/touch2ola/{0}".format (self.channelcounter)
        self.msg = osc_message_builder.OscMessageBuilder(address = msgaddress)
        self.msg.add_arg (val)
        self.msg = self.msg.build()
        self.client.send (self.msg)

    def get_dmx(self, arg1, arg2):
        self.chanval = arg2
        touch.sendvalue (int(self.chanval * 100))
#        return self.chanval
        
    def chanfader(self, arg1, arg2): # fader Handler
        self.get_dmx (arg1, arg2)
        self.sendval (arg2)
        
        
if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument("--ip",
        default="10.6.6.135", help="IP des Touch-Gerätes")
    parser.add_argument("--port",
        type=int, default=8000, help="In-Port für riggingtool.py")
    args = parser.parse_args()

# dieser Rechner:
    local_ip = get_ip_address()
# Gerät mit Touch-OSC:
    touch_ip = args.ip
# Gerät mit OLA:
    ola_ip = "127.0.0.1"
# Ports, gleich für Touch und OLA
    out_port = 7700
    in_port  = 8000

    touch = OscTouch ()
    ola   = OscOla ()

# Elemente des Layout rigging tool 1
    dispatcher = dispatcher.Dispatcher()
    dispatcher.map("/ola2touch/%d", ola.get_dmx)
    dispatcher.map("/1/fader1", ola.chanfader) # sends dmx
    dispatcher.map("/1/push1", touch.sub1)
    dispatcher.map("/1/push2", touch.add1)
    dispatcher.map("/1/push3", touch.sub10)
    dispatcher.map("/1/push4", touch.add10)
    dispatcher.map("/1/push5", touch.sub100)
    dispatcher.map("/1/push6", touch.add100)
    dispatcher.map("/1/push7", print)
    dispatcher.map("/2/push1", print)
    dispatcher.map("/2/push2", print)
    dispatcher.map("/2/push3", print)
    dispatcher.map("/2/rotary1", print)
    dispatcher.map("/2/fader1", print)
    dispatcher.map("/2/fader2", print)
    dispatcher.map("/2/fader3", print)
    dispatcher.map("/2/fader4", print)
    
    server = osc_server.ThreadingOSCUDPServer((local_ip, in_port), dispatcher)
    print("Serving on {}".format(server.server_address))
    
    server.serve_forever()
